## ros-eloquent-costmap-converter 0.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(costmap_converter)

# Set to Release in order to speed up the program significantly
set(CMAKE_BUILD_TYPE Release) #None, Debug, Release, RelWithDebInfo, MinSizeRel

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(class_loader REQUIRED)
find_package(costmap_converter_msgs REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(nav2_costmap_2d REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(OpenCV REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)

set(dependencies
    class_loader
    costmap_converter_msgs
    cv_bridge
    geometry_msgs
    nav2_costmap_2d
    tf2
    tf2_geometry_msgs
    tf2_ros
    OpenCV
    pluginlib
    rclcpp
)

include_directories(
  include
)

add_library(costmap_converter SHARED
  src/costmap_to_polygons.cpp 
  src/costmap_to_polygons_concave.cpp
  src/costmap_to_lines_convex_hull.cpp
  src/costmap_to_lines_ransac.cpp
  src/costmap_to_dynamic_obstacles/costmap_to_dynamic_obstacles.cpp
  src/costmap_to_dynamic_obstacles/background_subtractor.cpp
  src/costmap_to_dynamic_obstacles/blob_detector.cpp
  src/costmap_to_dynamic_obstacles/multitarget_tracker/Ctracker.cpp
  src/costmap_to_dynamic_obstacles/multitarget_tracker/Kalman.cpp
  src/costmap_to_dynamic_obstacles/multitarget_tracker/HungarianAlg.cpp
)

ament_target_dependencies(costmap_converter 
    ${dependencies}
)

add_executable(standalone_converter src/costmap_converter_node.cpp)

target_link_libraries(standalone_converter
    costmap_converter
)
ament_target_dependencies(standalone_converter
  ${dependencies}
)

install(TARGETS costmap_converter
   DESTINATION lib
)
install(TARGETS standalone_converter
   DESTINATION bin
)

install(DIRECTORY include/
   DESTINATION include/
)

ament_export_include_directories(include)
ament_export_libraries(costmap_converter)
ament_export_dependencies(${dependencies})
pluginlib_export_plugin_description_file(costmap_converter costmap_converter_plugins.xml)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  ament_add_gtest(test_costmap_polygons test/costmap_polygons.cpp)
  if(TARGET test_costmap_polygons)
    target_link_libraries(test_costmap_polygons costmap_converter)  
  endif()
  ament_target_dependencies(test_costmap_polygons ${dependencies})
endif()

ament_package()

=== debian/changelog ===
ros-eloquent-costmap-converter (0.1.1-1bionic) bionic; urgency=high

  * Fixed ament plugin export
  * Revert release-mode for cmake build
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Fri, 24 Jan 2020 23:00:00 -0000

ros-eloquent-costmap-converter (0.1.0-1bionic) bionic; urgency=high

  * Port to ROS2 (thanks to Vinnam Kim and stevemacenski)
  * Messages moved to a separate package
  * Contributors: Christoph Rösmann, Vinnam Kim, stevemacenski

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Wed, 22 Jan 2020 23:00:00 -0000

ros-eloquent-costmap-converter (0.0.12-1bionic) bionic; urgency=high

  * CostmapToPolygons: Simplification of the polygon by Douglas-Peucker algorithm (reduces the density of points in the polygon).
  * Bugfixes
  * Contributors: Rainer Kümmerle

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Sun, 01 Dec 2019 23:00:00 -0000

ros-eloquent-costmap-converter (0.0.11-1bionic) bionic; urgency=high

  * rostest integration to avoid running a roscore separately for unit testing
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Fri, 25 Oct 2019 22:00:00 -0000

ros-eloquent-costmap-converter (0.0.10-1bionic) bionic; urgency=high

  * Runtime improvements for CostmapToPolygonsDBSMCCH (#12 <https://github.com/rst-tu-dortmund/costmap_converter/issues/12>)
    * Grid lookup for regionQuery
    * use a grid structure for looking up nearest neighbors
    * parameters in a struct
    * guard the parameters by drawing a copy from dynamic reconfigure
    * Adding some test cases for regionQuery and dbScan
    * Avoid computing sqrt at the end of convexHull2
    * Add doxygen comments for the neighbor lookup
    * Change the param read to one liners
    * Add test on empty map for dbScan
  * Contributors: Rainer Kümmerle

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Fri, 25 Oct 2019 22:00:00 -0000

ros-eloquent-costmap-converter (0.0.9-1bionic) bionic; urgency=high

  * Moved plugin loader for static costmap conversion to BaseCostmapToDynamicObstacles.
    The corresponding ROS parameter static_converter_plugin is now defined in the CostmapToDynamicObstacles namespace.
  * Contributors: Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Sun, 27 May 2018 22:00:00 -0000

ros-eloquent-costmap-converter (0.0.8-1bionic) bionic; urgency=high

  * Standalone converter subscribes now to costmap updates. Fixes #1 <https://github.com/rst-tu-dortmund/costmap_converter/issues/1>
  * Adds radius field for circular obstacles to ObstacleMsg
  * Stacked costmap conversion (#7 <https://github.com/rst-tu-dortmund/costmap_converter/issues/7>).
    E.g., it is now possible combine a dynamic obstacle and static obstacle converter plugin.
  * Contributors: Christoph Rösmann, Franz Albers

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Wed, 16 May 2018 22:00:00 -0000

ros-eloquent-costmap-converter (0.0.7-1bionic) bionic; urgency=high

  * Fixed some compilation issues (C++11 compiler flags and opencv2 on indigo/jade).
  * Dynamic obstacle plugin: obstacle velocity is now published for both x and y coordinates rather than the absolute value

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Tue, 19 Sep 2017 22:00:00 -0000

ros-eloquent-costmap-converter (0.0.6-1bionic) bionic; urgency=high

  * This pull request adds the costmap to dynamic obstacles plugin (written by Franz Albers).
    It detects the dynamic foreground of the costmap (based on the temporal evolution of the costmap)
    including blobs representing the obstacles. Furthermore, Kalman-based tracking is applied to estimate
    the current velocity for each obstacle.
    **Note, this plugin is still experimental.**
  * New message types are introduced: costmap_converter::ObstacleMsg and costmap_converter::ObstacleArrayMsg.
    These types extend the previous polygon representation by additional velocity, orientation and id information.
  * The API has been extended to provide obstacles via the new ObstacleArrayMsg type instead of vector of polygons.
  * Contributors: Franz Albers, Christoph Rösmann

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Sun, 17 Sep 2017 22:00:00 -0000

ros-eloquent-costmap-converter (0.0.5-1bionic) bionic; urgency=high

  * Major changes regarding the line detection based on the convex hull
    (it should be much more robust now).
  * Concave hull plugin added.
  * The cluster size can now be limited from above using a specific parameter.
    This implicitly avoids large clusters forming a 'L' or 'U'.
  * All parameters can now be adjusted using dynamic_reconfigure (rqt_reconfigure).
  * Some parameter names changed.
  * Line plugin based on ransac: line inliers must now be placed inbetween the start and end of a line.

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Sun, 31 Jan 2016 23:00:00 -0000

ros-eloquent-costmap-converter (0.0.4-1bionic) bionic; urgency=high

  * Fixed conversion from map to world coordinates if the costmap is not quadratic.

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Sun, 10 Jan 2016 23:00:00 -0000

ros-eloquent-costmap-converter (0.0.3-1bionic) bionic; urgency=high

  * The argument list of the initialize method requires a nodehandle from now on. This facilitates the handling of parameter namespaces for multiple instantiations of the plugin.
  * This change is pushed immediately as a single release to avoid API breaks (since version 0.0.2 is not on the official repos up to now).

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Tue, 22 Dec 2015 23:00:00 -0000

ros-eloquent-costmap-converter (0.0.2-1bionic) bionic; urgency=high

  * Added a plugin for converting the costmap to lines using ransac

 -- Christoph Rösmann <christoph.roesmann@tu-dortmund.de>  Mon, 21 Dec 2015 23:00:00 -0000

ros-eloquent-costmap-converter (0.0.1-1bionic) bionic; urgency=high



=== debian/control ===
Source: ros-eloquent-costmap-converter
Section: misc
Priority: optional
Maintainer: Christoph Rösmann <christoph.roesmann@tu-dortmund.de>
Build-Depends: debhelper (>= 9.0.0), ros-eloquent-ament-cmake, ros-eloquent-ament-cmake-gtest, ros-eloquent-class-loader, ros-eloquent-costmap-converter-msgs, ros-eloquent-cv-bridge, ros-eloquent-geometry-msgs, ros-eloquent-nav2-costmap-2d, ros-eloquent-pluginlib, ros-eloquent-rclcpp, ros-eloquent-tf2, ros-eloquent-ros-workspace
Homepage: http://wiki.ros.org/costmap_converter
Standards-Version: 3.9.2

Package: ros-eloquent-costmap-converter
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-eloquent-class-loader, ros-eloquent-costmap-converter-msgs, ros-eloquent-cv-bridge, ros-eloquent-geometry-msgs, ros-eloquent-nav2-costmap-2d, ros-eloquent-pluginlib, ros-eloquent-rclcpp, ros-eloquent-tf2, ros-eloquent-ros-workspace
Description: A ros package that includes plugins and nodes to convert occupied costmap2d cells to primitive types.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-costmap-converter//opt/ros/eloquent/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
